version: '3'

services:
  yarn:
    image: node:18
    volumes:
      - .:/opt/header
    working_dir: /opt/header
    command: install
    entrypoint: yarn
    profiles:
      - dev

  webserver:
    image: node:18
    volumes:
      - .:/opt/header
    working_dir: /opt/header
    command: yarn webserver
    # build: .
    ports:
      - "4080:4080"
      - "24678:24678"
    environment:
      RPS_HEADER_WEBSERVER_ENV: dev
      RPS_HEADER_JS_URL: ${RPS_HEADER_JS_URL:-/header.js}
      VITE_RPS_HEADER_SIGN_IN_URL: ${RPS_HEADER_SIGN_IN_URL:-/oauth2/sign_in}
      VITE_RPS_HEADER_SIGN_OUT_URL: ${RPS_HEADER_SIGN_OUT_URL:-/oauth2/sign_out}
      VITE_RPS_HEADER_USERINFO_URL: ${RPS_HEADER_USERINFO_URL:-/oauth2/userinfo}
      VITE_RPS_HEADER_DYNAMIC_CONFIG_URL: ${RPS_HEADER_DYNAMIC_CONFIG_URL:-/config}
    profiles:
      - dev
    depends_on:
      yarn:
        condition: service_completed_successfully

  build:
    build: .
    ports:
      - "4080:4080"
    environment:
      RPS_HEADER_USERINFO_URL: ${RPS_HEADER_USERINFO_URL}
      RPS_HEADER_SIGN_IN_URL: ${RPS_HEADER_SIGN_IN_URL}
      RPS_HEADER_SIGN_OUT_URL: ${RPS_HEADER_SIGN_OUT_URL}
    profiles:
      - prod
